<?php
/*
Name: Blogger Beta Import
Version: 0.4
URI: http://www.romantika.name/v2/2006/12/19/import-blogger-beta-to-wordpress/
Description: Import Blogger Beta into WordPress
Author: Ady Romantika (ady@romantika.name)
Author URI: http://www.romantika.name/v2/

TODO
====
1. URL for non blogger commenters ## DONE 2006-12-22 ##

Please read my website for instructions and detailed info.

This script is licensed under GPL v2.

Changelog:
=========
2006-12-22 -	1. added ability to add commentor URL and email since these data can't be obtained from RSS.
				2. added extra checks to terminate script if something fails. No use wasting user time to wait for a broken result.
2006-01-01 -	1. Bugfix: if comment author's name contains an apostrophe it failed. Not anymore.
2007-01-10 -	1. added checking for available retrieving mechanism available on the server. Notify and die if none supported.
				2. added code utilizing curl to download file - suggested by Charles Wesley
				3. added support for incremental import to cope with speed problems
*/

session_start();
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Import Blogger Beta to WordPress 2.0.x</title>
<style type="text/css">
<!--
body,td {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 11px;
}
-->
</style>
	<body bgcolor="#c0c0c0">
		<h2>Import Blogger Beta to WordPress 2.0.x</h2>
<?php

require_once "./wp-config.php";

// Database connection
$link = mysql_connect(DB_HOST,DB_USER,DB_PASSWORD) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Connection failed - check configurations.');
if(!mysql_select_db(DB_NAME,$link)) die ('<br/><font color="red">ERROR: ['.mysql_error().']</font> Cannot select database.');

if(isset($_POST['blogger']) or isset($_POST['next']))
{
	// The first POST variable
	if(isset($_POST['blogger'])) $_SESSION['blogger'] = $_POST['blogger'];
	if(isset($_POST['category'])) $_SESSION['category'] = $_POST['category'];
	if(isset($_POST['user'])) $_SESSION['user'] = $_POST['user'];

	/***********************************************************************
	/ POSTS
	/**********************************************************************/
	// Reads XML file into formatted html
	function readXML($xmlFile,$mechanism)
	{
		$xmlParser = xml_parser_create();

		xml_parser_set_option($xmlParser, XML_OPTION_CASE_FOLDING, false);
		xml_set_element_handler($xmlParser, startElement, endElement);
		xml_set_character_data_handler($xmlParser, characterData);

		switch($mechanism)
		{
			case 'curl':
				$filedata = getCURL($xmlFile);
		        	xml_parse($xmlParser, $filedata, true);
			break;
			case 'fopen':
				$fp = fopen($xmlFile, "r") or die('Unable to extract post from '.$xmlFile);
				while($data = fread($fp, 8192))
				{
					xml_parse($xmlParser, $data, feof($fp));
				}
			break;
		}
		xml_parser_free($xmlParser);
	}

	// Sets the current XML element, and pushes itself onto the element hierarchy
	function startElement($parser, $name, $attrs)
	{
		global $currentElements, $itemCount;
		array_push($currentElements, $name);
		if($name == "item"){$itemCount += 1;}
	}

	// Prints XML data; finds highlights and links
	function characterData($parser, $data)
	{
		global $currentElements, $postsArray, $itemCount;

		$currentCount = count($currentElements);
		$parentElement = $currentElements[$currentCount-2];
		$thisElement = $currentElements[$currentCount-1];

		if($parentElement == "item")
		{
			$postsArray[$itemCount-1][$thisElement] .= $data;
		}
	}

	// If the XML element has ended, it is poped off the hierarchy
	function endElement($parser, $name)
	{
		global $currentElements;

		$currentCount = count($currentElements);
		if($currentElements[$currentCount-1] == $name)
		{
			array_pop($currentElements);
		}
	}

	/***********************************************************************
	/ COMMENTS
	/**********************************************************************/
	// Reads XML file into formatted html
	function readCXML($xmlFile,$mechanism)
	{
		$xmlParser = xml_parser_create();

		xml_parser_set_option($xmlParser, XML_OPTION_CASE_FOLDING, false);
		xml_set_element_handler($xmlParser, startCElement, endCElement);
		xml_set_character_data_handler($xmlParser, characterCData);

		switch($mechanism)
		{
			case 'curl':
		        	$filedata = getCURL($xmlFile);
		        	xml_parse($xmlParser, $filedata);
			break;
			case 'fopen':
				$fp = fopen($xmlFile, "r") or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Unable to extract comments from '.$xmlFile);
				while($data = fread($fp, 8192))
				{
					xml_parse($xmlParser, $data, feof($fp));
				}
			break;
		}
		xml_parser_free($xmlParser);
	}

	// Sets the current XML element, and pushes itself onto the element hierarchy
	function startCElement($parser, $name, $attrs)
	{
		global $currentCElements, $itemCCount;
		array_push($currentCElements, $name);
		if($name == "entry"){$itemCCount += 1;}
	}

	// Prints XML data; finds highlights and links
	function characterCData($parser, $data)
	{
		global $currentCElements, $commentsArray, $itemCCount;

		$currentCount = count($currentCElements);
		$parentElement = $currentCElements[$currentCount-2];
		$thisElement = $currentCElements[$currentCount-1];

		if($parentElement == "entry")
		{
			$commentsArray[$itemCCount-1][$thisElement] .= $data;
		}
		if($parentElement == "author")
		{
			$commentsArray[$itemCCount-1][$thisElement] .= $data;
		}
	}

	// If the XML element has ended, it is poped off the hierarchy
	function endCElement($parser, $name)
	{
		global $currentCElements;

		$currentCount = count($currentCElements);
		if($currentCElements[$currentCount-1] == $name)
		{
			array_pop($currentCElements);
		}
	}

	function getCURL($url)
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_HEADER, 0);												
		$filedata = curl_exec($ch);
		curl_close($ch);
		return $filedata;
	}

	/***********************************************************************
	/ MAIN
	/**********************************************************************/

	// Get general variables
	$basic_url = 'http://'.$_SESSION['blogger'].'.blogspot.com/feeds/posts/full?alt=rss&max-results=1&start-index=200000';
	$post_url = 'http://'.$_SESSION['blogger'].'.blogspot.com/feeds/posts/full?alt=rss&max-results='.$_SESSION['numposts'].'&start-index=';
	$comment_url = 'http://'.$_SESSION['blogger'].'.blogspot.com/feeds/XXXXXXXXXXXX/comments/default';

	$fp = '';

	// Decide which file mechanism to use - 1. fopen, 2. curl
	if(ini_get('allow_url_fopen'))
	{
		$mechanism = 'fopen';
	}
	else if(function_exists('curl_init'))
	{
		$mechanism = 'curl';
	}
	else
	{
		$mechanism = 'null';
		?>
Sorry. This script need either <b>allow_url_fopen</b> to be <b>On</b>, or the <a href="http://my2.php.net/manual/en/ref.curl.php"><b>curl extension</b></a> to be installed. I must stop now.
<hr>
Version 0.4 by <a href="http://www.romantika.name/v2/">Ady Romantika</a> (Ady at Romantika dot Name)

	</body>
</html>
		<?php
		exit;
	}

	// Only go through the trouble of getting the number of loop once
	if(!isset($_SESSION['numLoop']))
	{
		switch($mechanism)
		{
			case 'curl':
				$filedata = getCURL($basic_url);
			break;
			case 'fopen':
				$fp = fopen($basic_url,"r") or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Unable to extract initial data from '.$basic_url);
				$filedata = fread($fp,8192);
				fclose($fp);
			break;
		}

		$bloggerId = substr($filedata, strpos($filedata,'<atom:id>')+9, strpos($filedata,'</atom:id>')-strpos($filedata,'<atom:id>')-9);
		$_SESSION['bloggerId'] = preg_replace('/tag:\w+\.\w+\,\d+:blog-/','',$bloggerId);

		$_SESSION['numposts'] = $_POST['numposts'];

		// Too lazy to parse XML
		$_SESSION['totalPosts'] = substr($filedata, strpos($filedata,'<openSearch:totalResults>')+25, strpos($filedata,'</openSearch:totalResults>')-strpos($filedata,'<openSearch:totalResults>')-25);

		$numLoop = ceil($_SESSION['totalPosts']/$_SESSION['numposts']);
		$_SESSION['numLoop'] = $numLoop;
		$_SESSION['currLoop'] = $numLoop;
	}
	else
	{
		$_SESSION['currLoop']--;
	}

	print '<p>Blogger ID: ['.$_SESSION['bloggerId'].']</p>';
	print '<p>Number of posts: ['.$_SESSION['totalPosts'].']</p>';
	print '<p>Number of cycles: ['.$_SESSION['numLoop'].']</p>';
	print '<p>Number of cycles to go: ['.($_SESSION['currLoop']-1).']</p>';
	print '<p>Download mechanism: ['.$mechanism.']</p>';

	// Look for max post number
	$sql = 'SELECT max(ID) AS max FROM '.$table_prefix.'posts';
	$result = mysql_query($sql) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Unable to find max post from database. Script terminated.');
	$dat = mysql_fetch_object($result);

	$nextItem = $dat->max + 1;

	$currentElements = array();
	$postsArray = array();

	$currentCElements = array();
	$commentsArray = array();

	readXML($post_url.($_SESSION['currLoop'] * $_SESSION['numposts'] - ($_SESSION['numposts'] - 1)),$mechanism);

	$postsArray = array_reverse($postsArray);

	// Now that we have the data
	for($x=0;$x<$itemCount;$x++)
	{
		unset($itemCCount);
		unset($currentCElements);
		unset($commentsArray);
		$currentCElements = array();
		$commentsArray = array();

		// Get blogpost ID - useful to retrieve comments later
		$postsArray[$x]['blogpost-id'] = substr($postsArray[$x]['guid'],strpos($postsArray[$x]['guid'],'.post-')+6);
		// Debugging display
		if($_SESSION['currLoop'] == $_SESSION['numLoop'])
			print "<br>Post ".($_SESSION['totalPosts'] - $x)." read from XML: ".$postsArray[$x]['title']; //." - ".$postsArray[$x]['blogpost-id'];
		else
			print "<br>Post ".($_SESSION['numposts'] * $_SESSION['currLoop'] - $x)." read from XML: ".$postsArray[$x]['title']; //." - ".$postsArray[$x]['blogpost-id'];

		// Cleanup of javascript onblur thingies from images
		$postsArray[$x]['description'] = preg_replace('/\sonblur=\"(\w*\{*\}*\s*\.*\(*\)*\;*)*\"/','',$postsArray[$x]['description']);

		// Wed, 13 Dec 2006 15:27:00 +0000
		$datetime = strtotime($postsArray[$x]['pubDate']);
		$postDate = date("Y-m-d H:i:s",$datetime);
		$postDateGMT = gmdate("Y-m-d H:i:s",$datetime);

		// Post ID on WordPress
		$Post_ID = ($nextItem + $x);

		$sql = 'INSERT into '.$table_prefix.'posts(ID, post_category, post_author, post_date, post_date_gmt, post_content, post_title,';
		$sql.= 'post_name) VALUES ';
		$sql.= "(".$Post_ID.",".$_SESSION['category'].",".$_SESSION['user'].",'$postDate','$postDateGMT','";
		$sql.= str_replace(array('<br>','<BR>','<br/>','<BR/>','<br />','<BR />'), "\n", addslashes($postsArray[$x]['description']));
		$sql.= "','".addslashes($postsArray[$x]['title'])."','".sanitize_title_with_dashes($postsArray[$x]['title'])."')";
		mysql_query($sql,$link) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Error inserting post.');

		mysql_query("insert into ".$table_prefix."post2cat (post_id, category_id) values (".($nextItem + $x).",".$_SESSION['category'].")",$link) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Error relating post to category');

		mysql_query("update ".$table_prefix."categories set category_count = category_count + 1 WHERE cat_ID = ".$_SESSION['category'], $link) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Error incrementing category count');

		// Look for comments based on post ID
		readCXML(str_replace('XXXXXXXXXXXX',$postsArray[$x]['blogpost-id'],$comment_url),$mechanism);

		for($y=0;$y<$itemCCount;$y++)
		{
			$dates = explode('T',$commentsArray[$y]['published']);

			$dd = explode('-',$dates[0]); // directly usable
			$t1 = explode('.',$dates[1]);
			$tt = explode(':',$t1[0]); // usable

			$datetime = mktime($tt[0],$tt[1],$tt[2],$dd[1],$dd[2],$dd[0]);

			$commentDate = date("Y-m-d H:i:s",$datetime);
			$commentDateGMT = gmdate("Y-m-d H:i:s",$datetime);

			$sql = 'INSERT INTO '.$table_prefix.'comments (comment_post_ID, comment_author, comment_author_email,	comment_author_url, comment_date,';
			$sql.= 'comment_date_gmt, comment_content, comment_approved, user_id) VALUES ';
			$sql.= "($Post_ID,'".addslashes($commentsArray[$y]['name'])."','','','".$commentDate."','".$commentDateGMT."','".addslashes($commentsArray[$y]['content'])."',";
			$sql.= "'1', 0)";
			mysql_query($sql,$link) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Error inserting comment.: ['.$sql.'] - '.mysql_error());
			$sql = 'UPDATE '.$table_prefix.'posts SET comment_count = comment_count + 1 WHERE ID = '.$Post_ID;
			mysql_query($sql,$link) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Error incrementing comment count in post.');
		}
	}

	if($_SESSION['currLoop'] == 1)
	{
		echo '<h1>You\'re done!</h1>';
		echo '<h3>However if you want... you can map these comment authors to their website and emails</h3>';

		// Now look for comments author if user wants to
		$sql = 'SELECT comment_author,count(comment_author) AS count FROM '.$table_prefix.'comments GROUP BY comment_author ORDER BY count DESC';
		$result = mysql_query($sql,$link) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Error getting comments data');
		$numrows = mysql_num_rows($result);
		echo '<form method="POST" action="">';
		echo '<table border="1">';
		echo '<tr><td>Author</td><td>No of comments</td><td>Email</td><td>Website (please include http://)</td></tr>';
		for($x=0;$x<$numrows;$x++)
		{
			$data = mysql_fetch_object($result);
			echo '<tr>';
			echo '<td>'.$data->comment_author.'</td>';
			echo '<td>'.$data->count.'</td>';
			echo '<td><input type="text" name="email'.$x.'"></td>';
			echo '<td><input type="text" name="website'.$x.'"><input type="hidden" name="author'.$x.'" value="'.$data->comment_author.'"></td>';
			echo '</tr>';
		}
		echo '</table>';
		echo '<input type="hidden" name="commentcount" value="'.$numrows.'">';
		echo '<input type="submit" value="Save">';
		echo '</form>';
	}
	else
	{
		echo '<p>You are not done, there are more posts to be imported.</p>';
		echo '<form method="POST" action="">';
		echo '<input type="submit" name="next" value="Next &gt;&gt;">';
		echo '</form>';
	}
}
else if(isset($_POST['email0']))
{
	for($x=0;$x<31;$x++)
	{
		if($_POST['email'.$x] != '' || $_POST['website'.$x] != '')
		{
			$sql = 'UPDATE '.$table_prefix.'comments SET ';
			if($_POST['email'.$x] != '') $sql.= 'comment_author_email = \''.$_POST['email'.$x].'\' ';
			if($_POST['email'.$x] != '' && $_POST['website'.$x] != '') $sql.=',';
			if($_POST['website'.$x] != '') $sql.= 'comment_author_url=\''.$_POST['website'.$x].'\' ';
			$sql.= 'WHERE comment_author = \''.$_POST['author'.$x].'\'';
			mysql_query($sql,$link) or die('<br/><font color="red">ERROR: ['.mysql_error().']</font> Error updating commentor database.');
			echo '<br>Updated author '.$_POST['author'.$x];
		}
	}
	echo '<h1>Now you\'re really done!</h1>';
}
else
{
	$sql = "SELECT ID, user_login, user_nicename FROM ".$table_prefix."users";
	$result1 = mysql_query($sql);
	$sql = "SELECT cat_ID, cat_name FROM ".$table_prefix."categories";
	$result2 = mysql_query($sql);
?>

<form method="POST" action="">
Blogger ID: <input type="text" name="blogger">.blogspot.com<br/>
Default User:
<select name="user">
	<?php
		while($userdat = mysql_fetch_object($result1))
		{
			echo '<option value="'.$userdat->ID.'">'.$userdat->user_login.' ('.$userdat->user_nicename.')</option>';
		}
	?>
</select><br/>
Default Category:
<select name="category">
	<?php
		while($catdat = mysql_fetch_object($result2))
		{
			echo '<option value="'.$catdat->cat_ID.'">'.$catdat->cat_name.'</option>';
		}
	?>
</select><br/>
Number of posts per import cycle:
<select name="numposts">
	<option value="5">5</option>
	<option value="10">10</option>
	<option value="25">25</option>
	<option value="50">50</option>
	<option value="75">75</option>
	<option value="100" selected>100</option>
</select>(Change this only if you encounter problems due to bandwidth or server speed)
<br/>
<input type="submit" value="Import">
</form>

<?php
	if(isset($_SESSION['user'])) echo '<p>I suggest you hit refresh once again to make sure session is reset.</p>';

	unset($_SESSION['currLoop']);
    //unset($_SESSION['numposts']);
    unset($_SESSION['blogger']);
    unset($_SESSION['bloggerId']);
    unset($_SESSION['totalPosts']);
    unset($_SESSION['numLoop']);
    unset($_SESSION['category']);
    unset($_SESSION['user']);
}
?>
<hr>
Version 0.4 by <a href="http://www.romantika.name/v2/">Ady Romantika</a> (Ady at Romantika dot Name)

	</body>
</html>
